    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.data;
    034
    035import java.util.EventListener;
    036
    037/**
    038 * The base interface for datasets in Orson Charts.  All datasets must support
    039 * the change event notification mechanism.  The idea is that when a dataset
    040 * is changed, an event is passed to the plot.  The plot can react to this
    041 * event, then pass on the change event to the chart.  The chart in turn will
    042 * pass on the event and this can result in the chart being repainted (for
    043 * example, if the chart is displayed in a
    044 * {@link org.jfree.chart3d.Chart3DPanel}).
    045 */
    046public interface Dataset3D {
    047
    048    /**
    049     * Registers a change listener to receive notification of changes to the
    050     * dataset.
    051     *
    052     * @param listener  the listener ({@code null} not permitted).
    053     */
    054    void addChangeListener(Dataset3DChangeListener listener);
    055
    056    /**
    057     * De-registers a change listener so that it no longer receives notification
    058     * of changes to the dataset.
    059     *
    060     * @param listener  the listener ({@code null} not permitted).
    061     */
    062    void removeChangeListener(Dataset3DChangeListener listener);
    063
    064    /**
    065     * Returns {@code true} if the specified listener is registered with
    066     * the dataset, and {@code false} otherwise.  This method is used
    067     * for unit testing to confirm that listeners are removed correctly
    068     * following dataset switches.
    069     *
    070     * @param listener  the listener.
    071     *
    072     * @return A boolean.
    073     */
    074    boolean hasListener(EventListener listener);
    075}